﻿local VFrame = LibStub("AceAddon-3.0"):NewAddon("VFrame", "AceEvent-3.0", "AceTimer-3.0", "AceConsole-3.0")

-- Info: Frame for PvP infos and a PvP arena statistic frame
-- Tastks: gathering infos in arena, handling with data, displaying infos and statistics
-- Autor: Max David aka Vènomstrikè

-- All Frames generated with SimpleUI
-- Arena informations queried with LibArena-1.0

-- License: GNU General Public License version 2 (GPLv2)

-- Thanks to Phanx and all other Users on WowAce for the help to get this AddOn done!


-- TODO 
	-- Adding more infos to the MatchView (info about classes)
	-- Adding OverAll Elements (Best/Badest Counter)
	-- Creating ClassView
	-- Create functions to fill the ClassView

--------------Global Variables----------------
local accVersion = 1.9


local InfoFrame
local StatFrame
local MatchView
local StatView
local ClassView 
local DebugFrame

local PointDB
local MatchDB
local ClassDB
local StatDB
local LA
local QTIP

local firstPvPUpdate = true

local zc = {1,2,3,4,5}

local classtbl = {
	[62] = "Mage: Arcane",
	[63] = "Mage: Fire",
	[64] = "Mage: Frost",
	[65] = "Paladin: Holy",
	[66] = "Paladin: Protection",
	[70] = "Paladin: Retribution",
	[71] = "Warrior: Arms",
	[72] = "Warrior: Fury",
	[73] = "Warrior: Protection",
	[102] = "Druid: Balance",
	[103] = "Druid: Feral",
	[104] = "Druid: Guardian",
	[105] = "Druid: Restoration",
	[250] = "Death Knight: Blood",
	[251] = "Death Knight: Frost",
	[252] = "Death Knight: Unholy",
	[253] = "Hunter: Beast Mastery",
	[254] = "Hunter: Marksmanship",
	[255] = "Hunter: Survival",
	[256] = "Priest: Discipline",
	[257] = "Priest: Holy",
	[258] = "Priest: Shadow",
	[259] = "Rogue: Assassination",
	[260] = "Rogue: Combat",
	[261] = "Rogue: Subtlety",
	[262] = "Shaman: Elemental",
	[263] = "Shaman: Enhancement",
	[264] = "Shaman: Restoration",
	[265] = "Warlock: Affliction",
	[266] = "Warlock: Demonology",
	[267] = "Warlock: Destruction",
	[268] = "Monk: Brewmaster",
	[269] = "Monk: Windwalker",
	[270] = "Monk: Mistweaver",
}

local mapImg = {
	[1] = "Interface\\AddOns\\VFrame\\Images\\Maps\\uc",
	[2] = "Interface\\AddOns\\VFrame\\Images\\Maps\\dala",
	[3] = "Interface\\AddOns\\VFrame\\Images\\Maps\\nagrand",
	[4] = "Interface\\AddOns\\VFrame\\Images\\Maps\\panda",
	[5] = "Interface\\AddOns\\VFrame\\Images\\Maps\\schergrat",
	[6] = "Interface\\AddOns\\VFrame\\Images\\Maps\\uldum"
}

local pImg = {
	["cleared"] = "Interface\\AddOns\\VFrame\\Images\\State\\cleared",
	["leaved"] = "Interface\\AddOns\\VFrame\\Images\\State\\leaved",
	["gray"] = "Interface\\AddOns\\VFrame\\Images\\gray",
	["ni"] = "Interface\\AddOns\\VFrame\\Images\\State\\ni"
}

-- Workaround for setting up the infos in the statistic frames easier
local MatchViewtbl = {}
----------------------------------------------


function VFrame:OnInitialize() -- the initialize part 

	self:HASOS()

	self:print("AddOn succsessfully loaded!")

end

-----------------Method Part-----------------

function VFrame:StartingUpdate() -- starts the timer for getting ranked infos all 5 seconds 

		self:UpdateInfoFrame()
	 	self:ScheduleRepeatingTimer("UpdateInfoFrame", 30)

end

function VFrame:HASOS() -- handle all shit on start 

	self:RegisterChatCommand("vf", "HandleChatCommand")

	self.db = LibStub("AceDB-3.0"):New("VFrameDB")
	self.dbF = LibStub("AceDB-3.0"):New("FriendDB")
	self.db.RegisterCallback(self, "OnDatabaseShutdown", "SaveDB")

	self:HandleFirstLoad()

	self:GetDB()

	isit = false
	for i,n in pairs(PointDB) do
		if i == date("%d.%m.%Y") then isit = true end
	end

	if isit == false then
		points = {}
		 points.cp = 0
		 points.hp = 0
		 points.cpO = select(6, GetCurrencyListInfo(11))
		 points.hpO = select(6, GetCurrencyListInfo(10))
		 points.cpA = select(6, GetCurrencyListInfo(11))
		 points.hpA = select(6, GetCurrencyListInfo(10))

		PointDB[date("%d.%m.%Y")] = points
	end

	InfoFrame = self:CreateInfoFrame()
	StatFrame = self:CreateStatFrame()
	StatFrame:Hide()
	InfoFrame:Show()

	self:ScheduleTimer("StartingUpdate", 4)

	LA = LibStub("LibArena-1.0")
	LA.RegisterCallback(self, "MATCH_INFO_UPDATE")

	QTIP = LibStub("LibQTip-1.0")

end

function VFrame:HandleChatCommand(cmd) -- defines what to to when a chat command is typed 

	if cmd == "" then
		if InfoFrame:IsShown() then InfoFrame:Hide() else InfoFrame:Show() end 
	elseif cmd == "move" then
		if InfoFrame.resize:IsShown() then InfoFrame.resize:Hide() else InfoFrame.resize:Show() end
	elseif cmd == "wipe db" then
		VFrame:CreateDBStructure(); VFrame:GetDB(); ReloadUI()
	else
		VFrame:print("Commands: move | wipe [?] | vf ")
	end

end

function VFrame:createPlayerTooltips(group, player, ranks) -- creates the tooltips for the matchvie players 
	
	local function frame_OnEnter(self)

		if player.state == "cleared" then

			local tooltip = QTIP:Acquire("PlayerInfoTooltip", 1, "CENTER")
			self.tooltip = tooltip 
			   
			tooltip:AddHeader(player.name)

			tooltip:SetColumnColor(1,0,0,0,1)
			tooltip:AddLine("Player leaved or was AFK")
			tooltip:AddLine(player.race..", "..classtbl[player.spec])
			tooltip:SetLineTextColor(3, LA:getSpecColor(player.spec))

			tooltip:SmartAnchorTo(self)		

			tooltip:Show()

		elseif player.state == "normal" then

			local tooltip = QTIP:Acquire("PlayerInfoTooltip", 1, "CENTER")
			self.tooltip = tooltip 
			
			tooltip:AddHeader(player.name)

			for i,n in pairs(ranks) do 
				if n == player.dmg + player.heal then rank = i end
			end

			tooltip:SetColumnColor(1,0,0,0,1)
			tooltip:AddLine('Match Rank: '..rank)
			tooltip:AddLine(player.race..", "..classtbl[player.spec])
			tooltip:SetLineTextColor(2, 0.8, 0.8, 0.8, 1)
			tooltip:SetLineTextColor(3, LA:getSpecColor(player.spec))

			tooltip:SmartAnchorTo(self)

			tooltip:Show()

		else


		end
	end

	local function frame_OnLeave(self)
		if not self.tooltip then return end
	   QTIP:Release(self.tooltip)
	   self.tooltip = nil

	end

	group.Icon:SetScript("OnEnter", frame_OnEnter)
	group.Icon:SetScript("OnLeave", frame_OnLeave)

end

function VFrame:GetDB() -- Splits the VFrameDB var into all db's 
	
	dbs = self.db.char.dbs
	MatchDB = dbs.matchdb
	ClassDB = dbs.classdb
	StatDB = dbs.statdb
	PointDB = dbs.pointdb

end

function VFrame:HandleFirstLoad() -- Does the things that must be done at the first load of the addon 

	if not self.db.char.dbs then self:CreateDBStructure() end

end

function VFrame:CreateDBStructure() -- Creates the DB Structure that other functions can work with tables even if not match was played 
	
	dbs = {}

	do -- creating the structure for the stats db 
		matches = {}
		match = {}
		 match.start = 1

		matches[1] = match

		dbs.statdb = matches
	end

	do -- creating the structure for the class db 

		classes = {}
		played = {}

		for i,n in pairs(classtbl) do
			classes[i] = played
		end

		dbs.classdb = classes
	end

	do -- creating the structure for the match db 
			
		matches = {1,2,3,4,5}
		match = {}
		match.size = "2v2"
		match.win = true
		match.time = 200
		match.map = "Arena der Tol'vir"
		match.ownFac = 0
		match.ranked = true
		match.rating = 1000


		team = {1,2,3,4,5}
		for i,n in pairs(team) do 
			member = {}
				member.dmg = 10000
				member.heal = 10000
				member.name = "Vènomstrikè-player"
				member.spec = 251
				member.race = "Human"
				member.state = "normal"
			team[i] = member
		end

		enemys = {1,2,3,4,5}
		for i,n in pairs(enemys) do 
			enemy = {}
				enemy.dmg = 10000
				enemy.heal = 10000
				enemy.name = "Vènomstrikè-enemy"
				enemy.spec = 251
				enemy.race = "Human"
				enemy.state = "normal"
			enemys[i] = enemy
		end

		players = {}
		players.team = team
		players.enemys = enemys
		match.players = players

		match.dmg = 0
		match.heal = 0

		for i, n in pairs(matches) do
			matches[i] = match
		end

		dbs.matchdb = matches
	end


	do

		points = {
			["cp"] = 0,
			["hp"] = 0,
			["cpO"] = select(6, GetCurrencyListInfo(11)),
			["hpO"] = select(6, GetCurrencyListInfo(10)),
			["cpA"] = select(6, GetCurrencyListInfo(11)),
			["hpA"] = select(6, GetCurrencyListInfo(10))
		}

		pointsTable = {
			[tostring(date("%d.%m.%Y"))] = points
		}

		dbs.pointdb = pointsTable

	end

	self.db.char.dbs = dbs
	self:print("DB structure created, all informations set to 0")

end

function VFrame:SaveDB() -- saves all infos gathered to the DB 
	
	self:updatePvPPoints()

	dbs = {}
	 dbs.matchdb = MatchDB
	 dbs.classdb = ClassDB
	 dbs.statdb = StatDB
	 dbs.pointdb = PointDB
	self.db.char.dbs = dbs

end

function VFrame:CreateInfoFrame() -- creates the Info Frame 

	frame = CreateFrame("Frame", "InfoFrame", UIParent) 
	frame:SetSize(150, 70) 
	frame:SetPoint("CENTER") 
	texture = frame:CreateTexture() 
	texture:SetAllPoints() 
	texture:SetTexture(0,0,0,0.4) 
	frame.background = texture
	frame:EnableMouse(true)
	frame:SetMovable(true)
	frame:SetBackdropBorderColor(0, 0, 0, 0.9)

	-- moving frame
	frame.resize = CreateFrame("Frame", "InfoFrame_resize", frame) 
	frame.resize:SetSize(10, 10) 
	frame.resize:SetPoint("TOPRIGHT", 10, 0) 
	texturers = frame.resize:CreateTexture() 
	texturers:SetAllPoints() 
	texturers:SetTexture(0,0,0,1) 
	frame.resize.background = texturers
	frame.resize:EnableMouse(true)
	frame.resize:SetScript("OnMouseDown", function (self, value) InfoFrame:StartMoving() end) 
	frame.resize:SetScript("OnMouseUp", function (self, value) InfoFrame:StopMovingOrSizing() end)
	frame.resize:Hide()

	-- rating fonts
	frame.f = frame:CreateFontString(nil, "OVERLAY")
	frame.f:SetPoint("RIGHT", frame, "RIGHT", -130, -1)
	frame.f:SetFont("Fonts\\ARIALN.TTF", 20, "OUTLINE")
	frame.f:SetJustifyH("LEFT")
	frame.f:SetShadowOffset(1, -1)
	frame.f:SetTextColor(1, 1, 1)
	frame.f:SetText("")

	frame.t = frame:CreateFontString(nil, "OVERLAY")
	frame.t:SetPoint("RIGHT", frame, "RIGHT", -71, -1)
	frame.t:SetFont("Fonts\\ARIALN.TTF", 20, "OUTLINE")
	frame.t:SetJustifyH("LEFT")
	frame.t:SetShadowOffset(1, -1)
	frame.t:SetTextColor(1, 1, 1)
	frame.t:SetText("")

	frame.z = frame:CreateFontString(nil, "OVERLAY")
	frame.z:SetPoint("RIGHT", frame, "RIGHT", -5, -1)
	frame.z:SetFont("Fonts\\ARIALN.TTF", 20, "OUTLINE")
	frame.z:SetJustifyH("LEFT")
	frame.z:SetShadowOffset(1, -1)
	frame.z:SetTextColor(1, 1, 1)
	frame.z:SetText("Loading...")


	-- rating desc fonts
	frame.f2 = frame:CreateFontString(nil, "OVERLAY")
	frame.f2:SetPoint("TOP", frame, "TOP", 0, -11)
	frame.f2:SetFont("Fonts\\ARIALN.TTF", 11, "OUTLINE")
	frame.f2:SetJustifyH("LEFT")
	frame.f2:SetShadowOffset(1, -1)
	frame.f2:SetTextColor(0.9,0.9,0.1)
	frame.f2:SetText("")

	frame.t2 = frame:CreateFontString(nil, "OVERLAY")
	frame.t2:SetPoint("TOP", frame, "TOP", -60, -11)
	frame.t2:SetFont("Fonts\\ARIALN.TTF", 11, "OUTLINE")
	frame.t2:SetJustifyH("LEFT")
	frame.t2:SetShadowOffset(1, -1)
	frame.t2:SetTextColor(0.9,0.9,0.1)
	frame.t2:SetText("")

	frame.z2 = frame:CreateFontString(nil, "OVERLAY")
	frame.z2:SetPoint("TOP", frame, "TOP", 60, -11)
	frame.z2:SetFont("Fonts\\ARIALN.TTF", 11, "OUTLINE")
	frame.z2:SetJustifyH("LEFT")
	frame.z2:SetShadowOffset(1, -1)
	frame.z2:SetTextColor(0.9,0.9,0.1)
	frame.z2:SetText("")


	-- win loose ratio fonts
	frame.l = frame:CreateFontString(nil, "OVERLAY")
	frame.l:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -119, 5)
	frame.l:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
	frame.l:SetJustifyH("LEFT")
	frame.l:SetShadowOffset(1, -1)
	frame.l:SetTextColor(1, 1, 1)
	frame.l:SetText("")

	frame.w = frame:CreateFontString(nil, "OVERLAY")
	frame.w:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -60, 5)     
	frame.w:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
	frame.w:SetJustifyH("LEFT")
	frame.w:SetShadowOffset(1, -1)
	frame.w:SetTextColor(1, 1, 1)
	frame.w:SetText("")

	frame.r = frame:CreateFontString(nil, "OVERLAY")
	frame.r:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -3, 5)
	frame.r:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
	frame.r:SetJustifyH("LEFT")
	frame.r:SetShadowOffset(1, -1)
	frame.r:SetTextColor(1, 1, 1)
	frame.r:SetText("")

	
	-- InfoFrame Button
	frame.b = CreateFrame("Button", "InfoFrameB", frame, "UIPanelButtonTemplate")
	frame.b:SetSize(160, 20)
	frame.b:SetPoint("TOP", frame, 0, 12)
	frame.b.text = _G["InfoFrameB" .. "Text"]
	frame.b.text:SetText("Statistics")
	frame.b:SetScript("OnClick", function() VFrame:StatFrameButton() end )
	frame.b:Disable()

	frame:Hide()
	
 return frame 

end

function VFrame:CreateStatFrame() -- creates the Statistics Frame 

	backdropS = {
	  bgFile = pImg["gray"],  
	  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	  tile = true,
	  tileSize = 32,
	  edgeSize = 32,
	  insets = {
	    left = 11,
	    right = 12,
	    top = 12,
	    bottom = 11
	  }
	}

	frameM = CreateFrame("Frame", "StatFrame", UIParent)
	frameM:SetSize(770, 770)
	frameM:SetFrameStrata("DIALOG")
	frameM:SetPoint("CENTER", UIParent)
	frameM:SetBackdrop(backdropS)
	frameM:SetMovable(true)
	frameM:SetScript("OnMouseDown", function () frameM:StartMoving() end )
	frameM:SetScript("OnMouseUp", function () frameM:StopMovingOrSizing() end )

	frameM.under = CreateFrame("Frame", "StatFrameUnder", frameM)
	frameM.under:SetSize(770, 55)
	frameM.under:SetPoint("CENTER", frameM, 0, -400)
	frameM.under:SetBackdrop(backdropS)

	frameM.match = CreateFrame("Button", "btnMatch", frameM.under, "UIPanelButtonTemplate")
	frameM.match:SetSize(80, 25)
	frameM.match:SetPoint("BOTTOMLEFT", frameM.under, 20, 15)
	frameM.match.text = _G["btnMatch" .. "Text"]
	frameM.match.text:SetText("Matches")
	frameM.match:SetScript("OnClick", function() MatchView:Show(); ClassView:Hide(); StatView:Hide() end )

	frameM.class = CreateFrame("Button", "btnClass", frameM.under, "UIPanelButtonTemplate")
	frameM.class:SetSize(80, 25)
	frameM.class:SetPoint("BOTTOMLEFT", frameM.under, 105, 15)
	frameM.class.text = _G["btnClass" .. "Text"]
	frameM.class.text:SetText("Class Stats")
	frameM.class:SetScript("OnClick", function() MatchView:Hide(); ClassView:Show(); StatView:Hide() end )
	frameM.class:Disable()

	frameM.stat = CreateFrame("Button", "btnStat", frameM.under, "UIPanelButtonTemplate")
	frameM.stat:SetSize(80, 25)
	frameM.stat:SetPoint("BOTTOMLEFT", frameM.under, 190, 15)
	frameM.stat.text = _G["btnStat" .. "Text"]
	frameM.stat.text:SetText("Stats")
	frameM.stat:SetScript("OnClick", function() MatchView:Hide(); ClassView:Hide(); StatView:Show(); VFrame:FilterStats() end )

	frameM.bg = CreateFrame("Button", "btnBG", frameM.under, "UIPanelButtonTemplate")
	frameM.bg:SetSize(80, 25)
	frameM.bg:SetPoint("BOTTOMLEFT", frameM.under, 275, 15)
	frameM.bg.text = _G["btnBG" .. "Text"]
	frameM.bg.text:SetText("BG")
	frameM.bg:SetScript("OnClick", function()  end )
	frameM.bg:Disable()

	frameM.ply = CreateFrame("Button", "btnPlayer", frameM.under, "UIPanelButtonTemplate")
	frameM.ply:SetSize(80, 25)
	frameM.ply:SetPoint("BOTTOMLEFT", frameM.under, 360, 15)
	frameM.ply.text = _G["btnPlayer" .. "Text"]
	frameM.ply.text:SetText("Player")
	frameM.ply:SetScript("OnClick", function()  end )
	frameM.ply:Disable()

	frameM.misc = CreateFrame("Button", "btnMisc", frameM.under, "UIPanelButtonTemplate")
	frameM.misc:SetSize(80, 25)
	frameM.misc:SetPoint("BOTTOMLEFT", frameM.under, 445, 15)
	frameM.misc.text = _G["btnMisc" .. "Text"]
	frameM.misc.text:SetText("Misc")
	frameM.misc:SetScript("OnClick", function()  end )
	frameM.misc:Disable()


	frameM.close = CreateFrame("Button", "btnClose", frameM.under, "UIPanelButtonTemplate")
	frameM.close:SetSize(70, 25)
	frameM.close:SetPoint("BOTTOMRIGHT", frameM.under, -15, 15)
	frameM.close.text = _G["btnClose" .. "Text"]
	frameM.close.text:SetText("Close")
	frameM.close:SetScript("OnClick", function() StatFrame:Hide() end )


	-- creating m3Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frameM.e1 = CreateFrame("Frame", "e1", frameM)
	frameM.e1:SetSize(30, 30)
	frameM.e1:SetFrameStrata("DIALOG")
	frameM.e1:SetPoint("BOTTOMLEFT", frameM, 120, 20)
	frameM.e1:SetBackdrop(backdropS)

	frameM.e2 = CreateFrame("Frame", "e2", frameM)
	frameM.e2:SetSize(30, 30)
	frameM.e2:SetFrameStrata("DIALOG")
	frameM.e2:SetPoint("BOTTOMLEFT", frameM, 160, 20)
	frameM.e2:SetBackdrop(backdropS)

	frameM.se = frameM:CreateFontString(nil, "OVERLAY")
	frameM.se:SetPoint("BOTTOMLEFT", frameM, "BOTTOMLEFT", 25, 30)
	frameM.se:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frameM.se:SetJustifyH("LEFT")
	frameM.se:SetShadowOffset(1, -1)
	frameM.se:SetTextColor(1, 1, 1)
	frameM.se:SetText("Best Counters:")

	frameM.hp = frameM:CreateFontString(nil, "OVERLAY")
	frameM.hp:SetPoint("BOTTOMLEFT", frameM, "BOTTOMLEFT", 250, 15)
	frameM.hp:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frameM.hp:SetJustifyH("LEFT")
	frameM.hp:SetShadowOffset(1, -1)
	frameM.hp:SetTextColor(1, 1, 1)
	frameM.hp:SetText("Honor Points Today:")

	frameM.cp = frameM:CreateFontString(nil, "OVERLAY")
	frameM.cp:SetPoint("BOTTOMLEFT", frameM, "BOTTOMLEFT", 230, 35)
	frameM.cp:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frameM.cp:SetJustifyH("LEFT")
	frameM.cp:SetShadowOffset(1, -1)
	frameM.cp:SetTextColor(1, 1, 1)
	frameM.cp:SetText("Conquest Points Today:")

	self:CreateMatchView(frameM)
	self:CreateClassView(frameM)
	self:CreateStatView(frameM)

	MatchView:SetPoint("CENTER", frameM, 0, 15)
	ClassView:SetPoint("CENTER", frameM, 0, 15)
	StatView:SetPoint("CENTER", frameM, 0, 15)

	MatchView:Show()
	ClassView:Hide()
	StatView:Hide()

	-- filling the View Table for easier setting of the elements
	m = {}
		for i,n in pairs(zc) do 
			eg = {}
			if i == 1 then eg.wl = MatchView.m1WL; eg.icon = MatchView.m1Icon; eg.size = MatchView.m1S end
			if i == 2 then eg.wl = MatchView.m2WL; eg.icon = MatchView.m2Icon; eg.size = MatchView.m2S end
			if i == 3 then eg.wl = MatchView.m3WL; eg.icon = MatchView.m3Icon; eg.size = MatchView.m3S end
			if i == 4 then eg.wl = MatchView.m4WL; eg.icon = MatchView.m4Icon; eg.size = MatchView.m4S end
			if i == 5 then eg.wl = MatchView.m5WL; eg.icon = MatchView.m5Icon; eg.size = MatchView.m5S end
			m[i] = eg
		end

	mP = {}
		for i,n in pairs(zc) do 
			eg = {}
			if i == 1 then eg.Name = MatchView.mP1Name; eg.Icon = MatchView.mP1Icon; eg.Dmg = MatchView.mP1Dmg; eg.Heal = MatchView.mP1Heal end
			if i == 2 then eg.Name = MatchView.mP2Name; eg.Icon = MatchView.mP2Icon; eg.Dmg = MatchView.mP2Dmg; eg.Heal = MatchView.mP2Heal end
			if i == 3 then eg.Name = MatchView.mP3Name; eg.Icon = MatchView.mP3Icon; eg.Dmg = MatchView.mP3Dmg; eg.Heal = MatchView.mP3Heal end
			if i == 4 then eg.Name = MatchView.mP4Name; eg.Icon = MatchView.mP4Icon; eg.Dmg = MatchView.mP4Dmg; eg.Heal = MatchView.mP4Heal end
			if i == 5 then eg.Name = MatchView.mP5Name; eg.Icon = MatchView.mP5Icon; eg.Dmg = MatchView.mP5Dmg; eg.Heal = MatchView.mP5Heal end
			mP[i] = eg
		end

	mE = {}
		for i,n in pairs(zc) do 
			eg = {}
			if i == 1 then eg.Name = MatchView.mE1Name; eg.Icon = MatchView.mE1Icon; eg.Dmg = MatchView.mE1Dmg; eg.Heal = MatchView.mE1Heal end
			if i == 2 then eg.Name = MatchView.mE2Name; eg.Icon = MatchView.mE2Icon; eg.Dmg = MatchView.mE2Dmg; eg.Heal = MatchView.mE2Heal end
			if i == 3 then eg.Name = MatchView.mE3Name; eg.Icon = MatchView.mE3Icon; eg.Dmg = MatchView.mE3Dmg; eg.Heal = MatchView.mE3Heal end
			if i == 4 then eg.Name = MatchView.mE4Name; eg.Icon = MatchView.mE4Icon; eg.Dmg = MatchView.mE4Dmg; eg.Heal = MatchView.mE4Heal end
			if i == 5 then eg.Name = MatchView.mE5Name; eg.Icon = MatchView.mE5Icon; eg.Dmg = MatchView.mE5Dmg; eg.Heal = MatchView.mE5Heal end
			mE[i] = eg
		end

	MatchViewtbl.m = m
	MatchViewtbl.mP = mP
	MatchViewtbl.mE = mE


	return frameM

end

function VFrame:CreateMatchView(frameM) -- creates the MatchView 
	
	frame = CreateFrame("Frame", "MatchView", frameM)
	frame:SetSize(700, 680)
	frame:SetPoint("CENTER", UIParent)
	texture = frame:CreateTexture()
	texture:SetAllPoints()
	texture:SetTexture(0.05,0.05,0.05,1)
	frame.background = texture

	-- creating borderTop
	backdropS = {
	  -- path to the background texture
	  bgFile = nil,  
	  -- path to the border texture
	  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = true,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 32,
	  -- thickness of edge segments and square size of edge corners (in pixels)
	  edgeSize = 32,
	  -- distance from the edges of the frame to those of the background texture (in pixels)
	  insets = {
	    left = 11,
	    right = 12,
	    top = 12,
	    bottom = 11
	  }
	}
	frame.borderTop = CreateFrame("Frame", "borderTop", frame)
	frame.borderTop:SetSize(710, 125)
	frame.borderTop:SetFrameStrata("DIALOG")
	frame.borderTop:SetPoint("BOTTOMLEFT", frame, -5, 565)
	frame.borderTop:SetBackdrop(backdropS)

	-- creating borderBot
	frame.borderBot = CreateFrame("Frame", "borderBot", frame)
	frame.borderBot:SetSize(710, 190)
	frame.borderBot:SetPoint("BOTTOMLEFT", frame, -5, 390)
	frame.borderBot:SetBackdrop(backdropS)

	-- creating m1Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.m1Icon = CreateFrame("Frame", "m1Icon", frame)
	frame.m1Icon:SetSize(60, 60)
	frame.m1Icon:SetFrameStrata("DIALOG")
	frame.m1Icon:SetPoint("BOTTOMLEFT", frame, 23, 609)
	frame.m1Icon:SetBackdrop(backdropS)
	frame.m1Icon:SetScript("OnMouseUp", function () VFrame:StatFrameUpdateMatches(1) end)

	-- creating m2Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.m2Icon = CreateFrame("Frame", "m2Icon", frame)
	frame.m2Icon:SetSize(60, 60)
	frame.m2Icon:SetFrameStrata("DIALOG")
	frame.m2Icon:SetPoint("BOTTOMLEFT", frame, 148, 609)
	frame.m2Icon:SetBackdrop(backdropS)
	frame.m2Icon:SetScript("OnMouseUp", function () VFrame:StatFrameUpdateMatches(2) end)

	-- creating m3Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.m3Icon = CreateFrame("Frame", "m3Icon", frame)
	frame.m3Icon:SetSize(60, 60)
	frame.m3Icon:SetFrameStrata("DIALOG")
	frame.m3Icon:SetPoint("BOTTOMLEFT", frame, 281, 609)
	frame.m3Icon:SetBackdrop(backdropS)
	frame.m3Icon:SetScript("OnMouseUp", function () VFrame:StatFrameUpdateMatches(3) end)

	-- creating m4Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.m4Icon = CreateFrame("Frame", "m4Icon", frame)
	frame.m4Icon:SetSize(60, 60)
	frame.m4Icon:SetFrameStrata("DIALOG")
	frame.m4Icon:SetPoint("BOTTOMLEFT", frame, 416, 609)
	frame.m4Icon:SetBackdrop(backdropS)
	frame.m4Icon:SetScript("OnMouseUp", function () VFrame:StatFrameUpdateMatches(4) end)

	-- creating m5Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.m5Icon = CreateFrame("Frame", "m5Icon", frame)
	frame.m5Icon:SetSize(60, 60)
	frame.m5Icon:SetFrameStrata("DIALOG")
	frame.m5Icon:SetPoint("BOTTOMLEFT", frame, 557, 609)
	frame.m5Icon:SetBackdrop(backdropS)
	frame.m5Icon:SetScript("OnMouseUp", function () VFrame:StatFrameUpdateMatches(5) end)

	-- creating m1WL
	frame.m1WL = CreateFrame("Frame", "m1WL", frame)
	frame.m1WL:SetSize(20, 60)
	frame.m1WL:SetFrameStrata("DIALOG")
	frame.m1WL:SetPoint("BOTTOMLEFT", frame, 86, 609)
	texture = frame.m1WL:CreateTexture()
	texture:SetAllPoints()
	texture:SetTexture(0.5,0.5,0.5,1)
	frame.m1WL.texture = texture

	-- creating m2WL
	frame.m2WL = CreateFrame("Frame", "m2WL", frame)
	frame.m2WL:SetSize(20, 60)
	frame.m2WL:SetFrameStrata("DIALOG")
	frame.m2WL:SetPoint("BOTTOMLEFT", frame, 211, 609)
	texture = frame.m2WL:CreateTexture()
	texture:SetAllPoints()
	texture:SetTexture(0.5,0.5,0.5,1)
	frame.m2WL.texture = texture

	-- creating m3WL
	frame.m3WL = CreateFrame("Frame", "m3WL", frame)
	frame.m3WL:SetSize(20, 60)
	frame.m3WL:SetFrameStrata("DIALOG")
	frame.m3WL:SetPoint("BOTTOMLEFT", frame, 344, 609)
	texture = frame.m3WL:CreateTexture()
	texture:SetAllPoints()
	texture:SetTexture(0.5,0.5,0.5,1)
	frame.m3WL.texture = texture

	-- creating m4WL
	frame.m4WL = CreateFrame("Frame", "m4WL", frame)
	frame.m4WL:SetSize(20, 60)
	frame.m4WL:SetFrameStrata("DIALOG")
	frame.m4WL:SetPoint("BOTTOMLEFT", frame, 479, 609)
	texture = frame.m4WL:CreateTexture()
	texture:SetAllPoints()
	texture:SetTexture(0.5,0.5,0.5,1)
	frame.m4WL.texture = texture

	-- creating m5WL
	frame.m5WL = CreateFrame("Frame", "m5WL", frame)
	frame.m5WL:SetSize(20, 60)
	frame.m5WL:SetFrameStrata("DIALOG")
	frame.m5WL:SetPoint("BOTTOMLEFT", frame, 619, 609)
	texture = frame.m5WL:CreateTexture()
	texture:SetAllPoints()
	texture:SetTexture(0.5,0.5,0.5,1)
	frame.m5WL.texture = texture

	-- creating m1S
	frame.m1S = frame:CreateFontString(nil, "OVERLAY")
	frame.m1S:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 44, 590)
	frame.m1S:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.m1S:SetJustifyH("LEFT")
	frame.m1S:SetShadowOffset(1, -1)
	frame.m1S:SetTextColor(1, 1, 1)
	frame.m1S:SetText("2v2")

	-- creating m2S
	frame.m2S = frame:CreateFontString(nil, "OVERLAY")
	frame.m2S:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 169, 589)
	frame.m2S:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.m2S:SetJustifyH("LEFT")
	frame.m2S:SetShadowOffset(1, -1)
	frame.m2S:SetTextColor(1, 1, 1)
	frame.m2S:SetText("2v2")

	-- creating m3S
	frame.m3S = frame:CreateFontString(nil, "OVERLAY")
	frame.m3S:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 303, 590)
	frame.m3S:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.m3S:SetJustifyH("LEFT")
	frame.m3S:SetShadowOffset(1, -1)
	frame.m3S:SetTextColor(1, 1, 1)
	frame.m3S:SetText("2v2")

	-- creating m4S
	frame.m4S = frame:CreateFontString(nil, "OVERLAY")
	frame.m4S:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 438, 590)
	frame.m4S:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.m4S:SetJustifyH("LEFT")
	frame.m4S:SetShadowOffset(1, -1)
	frame.m4S:SetTextColor(1, 1, 1)
	frame.m4S:SetText("2v2")

	-- creating m5S
	frame.m5S = frame:CreateFontString(nil, "OVERLAY")
	frame.m5S:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 577, 590)
	frame.m5S:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.m5S:SetJustifyH("LEFT")
	frame.m5S:SetShadowOffset(1, -1)
	frame.m5S:SetTextColor(1, 1, 1)
	frame.m5S:SetText("2v2")

	-- creating mIcon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.mIcon = CreateFrame("Frame", "mIcon", frame)
	frame.mIcon:SetSize(100, 100)
	frame.mIcon:SetFrameStrata("DIALOG")
	frame.mIcon:SetPoint("BOTTOMLEFT", frame, 56, 427)
	frame.mIcon:SetBackdrop(backdropS)
	frame.mIcon:SetScript("OnMouseUp", function ()  end)

	-- creating mIconS
	frame.mIconS = frame:CreateFontString(nil, "OVERLAY")
	frame.mIconS:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 61, 543)
	frame.mIconS:SetFont("Fonts\\ARIALN.TTF", 20, "OUTLINE")
	frame.mIconS:SetJustifyH("LEFT")
	frame.mIconS:SetShadowOffset(1, -1)
	frame.mIconS:SetTextColor(1, 1, 1)
	frame.mIconS:SetText("Map")

	-- creating mWL
	frame.mWL = CreateFrame("Frame", "mWL", frame)
	frame.mWL:SetSize(20, 100)
	frame.mWL:SetFrameStrata("DIALOG")
	frame.mWL:SetPoint("BOTTOMLEFT", frame, 160, 427)
	texture = frame.mWL:CreateTexture()
	texture:SetAllPoints()
	texture:SetTexture(0.5,0.5,0.5,1)
	frame.mWL.texture = texture

	-- creating mSize
	frame.mSize = frame:CreateFontString(nil, "OVERLAY")
	frame.mSize:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 301, 466)
	frame.mSize:SetFont("Fonts\\ARIALN.TTF", 25, "OUTLINE")
	frame.mSize:SetJustifyH("LEFT")
	frame.mSize:SetShadowOffset(1, -1)
	frame.mSize:SetTextColor(1, 1, 1)
	frame.mSize:SetText("2v2")

	-- creating mRanked
	frame.mRanked = frame:CreateFontString(nil, "OVERLAY")
	frame.mRanked:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 395, 466)
	frame.mRanked:SetFont("Fonts\\ARIALN.TTF", 25, "OUTLINE")
	frame.mRanked:SetJustifyH("LEFT")
	frame.mRanked:SetShadowOffset(1, -1)
	frame.mRanked:SetTextColor(1, 1, 1)
	frame.mRanked:SetText("Ranked")

	-- creating mTime
	frame.mTime = frame:CreateFontString(nil, "OVERLAY")
	frame.mTime:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 525, 465)
	frame.mTime:SetFont("Fonts\\ARIALN.TTF", 25, "OUTLINE")
	frame.mTime:SetJustifyH("LEFT")
	frame.mTime:SetShadowOffset(1, -1)
	frame.mTime:SetTextColor(1, 1, 1)
	frame.mTime:SetText("Time")

	-- creating mRating
	frame.mRating = frame:CreateFontString(nil, "OVERLAY")
	frame.mRating:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 362, 525)
	frame.mRating:SetFont("Fonts\\ARIALN.TTF", 25, "OUTLINE")
	frame.mRating:SetJustifyH("LEFT")
	frame.mRating:SetShadowOffset(1, -1)
	frame.mRating:SetTextColor(1, 1, 1)
	frame.mRating:SetText("At Rating:")

	-- creating mE1Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.mE1Icon = CreateFrame("Frame", "mE1Icon", frame)
	frame.mE1Icon:SetSize(60, 60)
	frame.mE1Icon:SetFrameStrata("DIALOG")
	frame.mE1Icon:SetPoint("BOTTOMLEFT", frame, 60, 106)
	frame.mE1Icon:SetBackdrop(backdropS)
	frame.mE1Icon:SetScript("OnMouseUp", function ()  end)

	-- creating mE2Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.mE2Icon = CreateFrame("Frame", "mE2Icon", frame)
	frame.mE2Icon:SetSize(60, 60)
	frame.mE2Icon:SetFrameStrata("DIALOG")
	frame.mE2Icon:SetPoint("BOTTOMLEFT", frame, 182, 105)
	frame.mE2Icon:SetBackdrop(backdropS)
	frame.mE2Icon:SetScript("OnMouseUp", function ()  end)

	-- creating mE3Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.mE3Icon = CreateFrame("Frame", "mE3Icon", frame)
	frame.mE3Icon:SetSize(60, 60)
	frame.mE3Icon:SetFrameStrata("DIALOG")
	frame.mE3Icon:SetPoint("BOTTOMLEFT", frame, 313, 105)
	frame.mE3Icon:SetBackdrop(backdropS)
	frame.mE3Icon:SetScript("OnMouseUp", function ()  end)

	-- creating mE4Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.mE4Icon = CreateFrame("Frame", "mE4Icon", frame)
	frame.mE4Icon:SetSize(60, 60)
	frame.mE4Icon:SetFrameStrata("DIALOG")
	frame.mE4Icon:SetPoint("BOTTOMLEFT", frame, 441, 105)
	frame.mE4Icon:SetBackdrop(backdropS)
	frame.mE4Icon:SetScript("OnMouseUp", function ()  end)

	-- creating mE5Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.mE5Icon = CreateFrame("Frame", "mE5Icon", frame)
	frame.mE5Icon:SetSize(60, 60)
	frame.mE5Icon:SetFrameStrata("DIALOG")
	frame.mE5Icon:SetPoint("BOTTOMLEFT", frame, 567, 104)
	frame.mE5Icon:SetBackdrop(backdropS)
	frame.mE5Icon:SetScript("OnMouseUp", function ()  end)

	-- creating mP1Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.mP1Icon = CreateFrame("Frame", "mP1Icon", frame)
	frame.mP1Icon:SetSize(60, 60)
	frame.mP1Icon:SetFrameStrata("DIALOG")
	frame.mP1Icon:SetPoint("BOTTOMLEFT", frame, 62, 305)
	frame.mP1Icon:SetBackdrop(backdropS)
	frame.mP1Icon:SetScript("OnMouseUp", function ()  end)

	-- creating mP2Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.mP2Icon = CreateFrame("Frame", "mP2Icon", frame)
	frame.mP2Icon:SetSize(60, 60)
	frame.mP2Icon:SetFrameStrata("DIALOG")
	frame.mP2Icon:SetPoint("BOTTOMLEFT", frame, 181, 303)
	frame.mP2Icon:SetBackdrop(backdropS)
	frame.mP2Icon:SetScript("OnMouseUp", function ()  end)

	-- creating mP3Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.mP3Icon = CreateFrame("Frame", "mP3Icon", frame)
	frame.mP3Icon:SetSize(60, 60)
	frame.mP3Icon:SetFrameStrata("DIALOG")
	frame.mP3Icon:SetPoint("BOTTOMLEFT", frame, 312, 303)
	frame.mP3Icon:SetBackdrop(backdropS)
	frame.mP3Icon:SetScript("OnMouseUp", function ()  end)

	-- creating mP4Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.mP4Icon = CreateFrame("Frame", "mP4Icon", frame)
	frame.mP4Icon:SetSize(60, 60)
	frame.mP4Icon:SetFrameStrata("DIALOG")
	frame.mP4Icon:SetPoint("BOTTOMLEFT", frame, 436, 302)
	frame.mP4Icon:SetBackdrop(backdropS)
	frame.mP4Icon:SetScript("OnMouseUp", function ()  end)

	-- creating mP5Icon
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(148910)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.mP5Icon = CreateFrame("Frame", "mP5Icon", frame)
	frame.mP5Icon:SetSize(60, 60)
	frame.mP5Icon:SetFrameStrata("DIALOG")
	frame.mP5Icon:SetPoint("BOTTOMLEFT", frame, 563, 300)
	frame.mP5Icon:SetBackdrop(backdropS)
	frame.mP5Icon:SetScript("OnMouseUp", function ()  end)

	-- creating borderVS
	backdropS = {
	  -- path to the background texture
	  bgFile = nil,  
	  -- path to the border texture
	  edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = true,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 32,
	  -- thickness of edge segments and square size of edge corners (in pixels)
	  edgeSize = 32,
	  -- distance from the edges of the frame to those of the background texture (in pixels)
	  insets = {
	    left = 11,
	    right = 12,
	    top = 12,
	    bottom = 11
	  }
	}
	frame.borderVS = CreateFrame("Frame", "borderVS", frame)
	frame.borderVS:SetSize(710, 410)
	frame.borderVS:SetPoint("BOTTOMLEFT", frame, -5, -5)
	frame.borderVS:SetBackdrop(backdropS)

	frame.borderVS2 = CreateFrame("Frame", "borderVS2", frame)
	frame.borderVS2:SetSize(670, 5)
	frame.borderVS2:SetPoint("BOTTOMLEFT", frame, 15, 207)
	texture = frame.borderVS2:CreateTexture()
	texture:SetAllPoints()
	texture:SetTexture(0.2, 0.2, 0.2, 0.9)

	-- creating cutVS
	frame.cutVS = frame.borderVS2:CreateFontString(nil, "DIALOG")
	frame.cutVS:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 328, 197)
	frame.cutVS:SetFont("Fonts\\ARIALN.TTF", 25, "OUTLINE")
	frame.cutVS:SetJustifyH("LEFT")
	frame.cutVS:SetShadowOffset(1, -1)
	frame.cutVS:SetTextColor(1, 1, 1)
	frame.cutVS:SetText("VS")

	-- creating mP1Name
	frame.mP1Name = frame:CreateFontString(nil, "OVERLAY")
	frame.mP1Name:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 43, 370)
	frame.mP1Name:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP1Name:SetJustifyH("LEFT")
	frame.mP1Name:SetShadowOffset(1, -1)
	frame.mP1Name:SetTextColor(1, 1, 1)
	frame.mP1Name:SetText("Name")

	-- creating mP2Name
	frame.mP2Name = frame:CreateFontString(nil, "OVERLAY")
	frame.mP2Name:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 161, 369)
	frame.mP2Name:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP2Name:SetJustifyH("LEFT")
	frame.mP2Name:SetShadowOffset(1, -1)
	frame.mP2Name:SetTextColor(1, 1, 1)
	frame.mP2Name:SetText("Name")

	-- creating mP3Name
	frame.mP3Name = frame:CreateFontString(nil, "OVERLAY")
	frame.mP3Name:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 294, 369)
	frame.mP3Name:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP3Name:SetJustifyH("LEFT")
	frame.mP3Name:SetShadowOffset(1, -1)
	frame.mP3Name:SetTextColor(1, 1, 1)
	frame.mP3Name:SetText("Name")

	-- creating mP4Name
	frame.mP4Name = frame:CreateFontString(nil, "OVERLAY")
	frame.mP4Name:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 417, 369)
	frame.mP4Name:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP4Name:SetJustifyH("LEFT")
	frame.mP4Name:SetShadowOffset(1, -1)
	frame.mP4Name:SetTextColor(1, 1, 1)
	frame.mP4Name:SetText("Name")

	-- creating mP5Name
	frame.mP5Name = frame:CreateFontString(nil, "OVERLAY")
	frame.mP5Name:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 545, 368)
	frame.mP5Name:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP5Name:SetJustifyH("LEFT")
	frame.mP5Name:SetShadowOffset(1, -1)
	frame.mP5Name:SetTextColor(1, 1, 1)
	frame.mP5Name:SetText("Name")

	-- creating mEDmg
	frame.mEDmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mEDmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 110, 11)
	frame.mEDmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mEDmg:SetJustifyH("LEFT")
	frame.mEDmg:SetShadowOffset(1, -1)
	frame.mEDmg:SetTextColor(1, 1, 1)
	frame.mEDmg:SetText("Dmg")

	-- creating mEHeal
	frame.mEHeal = frame:CreateFontString(nil, "OVERLAY")
	frame.mEHeal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 464, 9)
	frame.mEHeal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mEHeal:SetJustifyH("LEFT")
	frame.mEHeal:SetShadowOffset(1, -1)
	frame.mEHeal:SetTextColor(1, 1, 1)
	frame.mEHeal:SetText("Heal")

	-- creating mElbDmg
	frame.mElbDmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mElbDmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 33, 11)
	frame.mElbDmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mElbDmg:SetJustifyH("LEFT")
	frame.mElbDmg:SetShadowOffset(1, -1)
	frame.mElbDmg:SetTextColor(1, 1, 1)
	frame.mElbDmg:SetText("All Damage:")

	-- creating mElbHeal
	frame.mElbHeal = frame:CreateFontString(nil, "OVERLAY")
	frame.mElbHeal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 410, 9)
	frame.mElbHeal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mElbHeal:SetJustifyH("LEFT")
	frame.mElbHeal:SetShadowOffset(1, -1)
	frame.mElbHeal:SetTextColor(1, 1, 1)
	frame.mElbHeal:SetText("All Heal:")

	-- creating mPlbDmg
	frame.mPlbDmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mPlbDmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 33, 228)
	frame.mPlbDmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mPlbDmg:SetJustifyH("LEFT")
	frame.mPlbDmg:SetShadowOffset(1, -1)
	frame.mPlbDmg:SetTextColor(1, 1, 1)
	frame.mPlbDmg:SetText("All Damage:")

	-- creating mPlbHeal
	frame.mPlbHeal = frame:CreateFontString(nil, "OVERLAY")
	frame.mPlbHeal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 410, 225)
	frame.mPlbHeal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mPlbHeal:SetJustifyH("LEFT")
	frame.mPlbHeal:SetShadowOffset(1, -1)
	frame.mPlbHeal:SetTextColor(1, 1, 1)
	frame.mPlbHeal:SetText("All Heal:")

	-- creating mPHeal
	frame.mPHeal = frame:CreateFontString(nil, "OVERLAY")
	frame.mPHeal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 464, 225)
	frame.mPHeal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mPHeal:SetJustifyH("LEFT")
	frame.mPHeal:SetShadowOffset(1, -1)
	frame.mPHeal:SetTextColor(1, 1, 1)
	frame.mPHeal:SetText("Heal")

	-- creating mPDmg
	frame.mPDmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mPDmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 110, 228)
	frame.mPDmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mPDmg:SetJustifyH("LEFT")
	frame.mPDmg:SetShadowOffset(1, -1)
	frame.mPDmg:SetTextColor(1, 1, 1)
	frame.mPDmg:SetText("Dmg")

	-- creating mE1Name
	frame.mE1Name = frame:CreateFontString(nil, "OVERLAY")
	frame.mE1Name:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 43, 173)
	frame.mE1Name:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE1Name:SetJustifyH("LEFT")
	frame.mE1Name:SetShadowOffset(1, -1)
	frame.mE1Name:SetTextColor(1, 1, 1)
	frame.mE1Name:SetText("Name")

	-- creating mE2Name
	frame.mE2Name = frame:CreateFontString(nil, "OVERLAY")
	frame.mE2Name:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 165, 172)
	frame.mE2Name:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE2Name:SetJustifyH("LEFT")
	frame.mE2Name:SetShadowOffset(1, -1)
	frame.mE2Name:SetTextColor(1, 1, 1)
	frame.mE2Name:SetText("Name")

	-- creating mE3Name
	frame.mE3Name = frame:CreateFontString(nil, "OVERLAY")
	frame.mE3Name:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 296, 170)
	frame.mE3Name:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE3Name:SetJustifyH("LEFT")
	frame.mE3Name:SetShadowOffset(1, -1)
	frame.mE3Name:SetTextColor(1, 1, 1)
	frame.mE3Name:SetText("Name")

	-- creating mE4Name
	frame.mE4Name = frame:CreateFontString(nil, "OVERLAY")
	frame.mE4Name:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 423, 171)
	frame.mE4Name:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE4Name:SetJustifyH("LEFT")
	frame.mE4Name:SetShadowOffset(1, -1)
	frame.mE4Name:SetTextColor(1, 1, 1)
	frame.mE4Name:SetText("Name")

	-- creating mE5Name
	frame.mE5Name = frame:CreateFontString(nil, "OVERLAY")
	frame.mE5Name:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 550, 169)
	frame.mE5Name:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE5Name:SetJustifyH("LEFT")
	frame.mE5Name:SetShadowOffset(1, -1)
	frame.mE5Name:SetTextColor(1, 1, 1)
	frame.mE5Name:SetText("Name")

	-- creating mP1Dmg
	frame.mP1Dmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mP1Dmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 68, 284)
	frame.mP1Dmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP1Dmg:SetJustifyH("LEFT")
	frame.mP1Dmg:SetShadowOffset(1, -1)
	frame.mP1Dmg:SetTextColor(1, 1, 1)
	frame.mP1Dmg:SetText("Dmg")

	-- creating mP1Heal
	frame.mP1Heal = frame:CreateFontString(nil, "OVERLAY")
	frame.mP1Heal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 68, 259)
	frame.mP1Heal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP1Heal:SetJustifyH("LEFT")
	frame.mP1Heal:SetShadowOffset(1, -1)
	frame.mP1Heal:SetTextColor(1, 1, 1)
	frame.mP1Heal:SetText("Heal")

	-- creating mP2Dmg
	frame.mP2Dmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mP2Dmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 188, 282)
	frame.mP2Dmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP2Dmg:SetJustifyH("LEFT")
	frame.mP2Dmg:SetShadowOffset(1, -1)
	frame.mP2Dmg:SetTextColor(1, 1, 1)
	frame.mP2Dmg:SetText("Dmg")

	-- creating mP2Heal
	frame.mP2Heal = frame:CreateFontString(nil, "OVERLAY")
	frame.mP2Heal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 188, 260)
	frame.mP2Heal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP2Heal:SetJustifyH("LEFT")
	frame.mP2Heal:SetShadowOffset(1, -1)
	frame.mP2Heal:SetTextColor(1, 1, 1)
	frame.mP2Heal:SetText("Heal")

	-- creating mP3Dmg
	frame.mP3Dmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mP3Dmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 320, 283)
	frame.mP3Dmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP3Dmg:SetJustifyH("LEFT")
	frame.mP3Dmg:SetShadowOffset(1, -1)
	frame.mP3Dmg:SetTextColor(1, 1, 1)
	frame.mP3Dmg:SetText("Dmg")

	-- creating mP3Heal
	frame.mP3Heal = frame:CreateFontString(nil, "OVERLAY")
	frame.mP3Heal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 320, 261)
	frame.mP3Heal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP3Heal:SetJustifyH("LEFT")
	frame.mP3Heal:SetShadowOffset(1, -1)
	frame.mP3Heal:SetTextColor(1, 1, 1)
	frame.mP3Heal:SetText("Heal")

	-- creating mP4Dmg
	frame.mP4Dmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mP4Dmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 443, 281)
	frame.mP4Dmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP4Dmg:SetJustifyH("LEFT")
	frame.mP4Dmg:SetShadowOffset(1, -1)
	frame.mP4Dmg:SetTextColor(1, 1, 1)
	frame.mP4Dmg:SetText("Dmg")

	-- creating mP4Heal
	frame.mP4Heal = frame:CreateFontString(nil, "OVERLAY")
	frame.mP4Heal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 443, 260)
	frame.mP4Heal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP4Heal:SetJustifyH("LEFT")
	frame.mP4Heal:SetShadowOffset(1, -1)
	frame.mP4Heal:SetTextColor(1, 1, 1)
	frame.mP4Heal:SetText("Heal")

	-- creating mP5Dmg
	frame.mP5Dmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mP5Dmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 569, 280)
	frame.mP5Dmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP5Dmg:SetJustifyH("LEFT")
	frame.mP5Dmg:SetShadowOffset(1, -1)
	frame.mP5Dmg:SetTextColor(1, 1, 1)
	frame.mP5Dmg:SetText("Dmg")

	-- creating mP5Heal
	frame.mP5Heal = frame:CreateFontString(nil, "OVERLAY")
	frame.mP5Heal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 569, 259)
	frame.mP5Heal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mP5Heal:SetJustifyH("LEFT")
	frame.mP5Heal:SetShadowOffset(1, -1)
	frame.mP5Heal:SetTextColor(1, 1, 1)
	frame.mP5Heal:SetText("Heal")

	-- creating mE1Dmg
	frame.mE1Dmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mE1Dmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 64, 85)
	frame.mE1Dmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE1Dmg:SetJustifyH("LEFT")
	frame.mE1Dmg:SetShadowOffset(1, -1)
	frame.mE1Dmg:SetTextColor(1, 1, 1)
	frame.mE1Dmg:SetText("Dmg")

	-- creating mE1Heal
	frame.mE1Heal = frame:CreateFontString(nil, "OVERLAY")
	frame.mE1Heal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 64, 62)
	frame.mE1Heal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE1Heal:SetJustifyH("LEFT")
	frame.mE1Heal:SetShadowOffset(1, -1)
	frame.mE1Heal:SetTextColor(1, 1, 1)
	frame.mE1Heal:SetText("Heal")

	-- creating mE2Dmg
	frame.mE2Dmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mE2Dmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 189, 83)
	frame.mE2Dmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE2Dmg:SetJustifyH("LEFT")
	frame.mE2Dmg:SetShadowOffset(1, -1)
	frame.mE2Dmg:SetTextColor(1, 1, 1)
	frame.mE2Dmg:SetText("Dmg")

	-- creating mE2Heal
	frame.mE2Heal = frame:CreateFontString(nil, "OVERLAY")
	frame.mE2Heal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 189, 61)
	frame.mE2Heal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE2Heal:SetJustifyH("LEFT")
	frame.mE2Heal:SetShadowOffset(1, -1)
	frame.mE2Heal:SetTextColor(1, 1, 1)
	frame.mE2Heal:SetText("Heal")

	-- creating mE3Dmg
	frame.mE3Dmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mE3Dmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 319, 84)
	frame.mE3Dmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE3Dmg:SetJustifyH("LEFT")
	frame.mE3Dmg:SetShadowOffset(1, -1)
	frame.mE3Dmg:SetTextColor(1, 1, 1)
	frame.mE3Dmg:SetText("Dmg")

	-- creating mE3Heal
	frame.mE3Heal = frame:CreateFontString(nil, "OVERLAY")
	frame.mE3Heal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 319, 63)
	frame.mE3Heal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE3Heal:SetJustifyH("LEFT")
	frame.mE3Heal:SetShadowOffset(1, -1)
	frame.mE3Heal:SetTextColor(1, 1, 1)
	frame.mE3Heal:SetText("Heal")

	-- creating mE4Dmg
	frame.mE4Dmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mE4Dmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 449, 86)
	frame.mE4Dmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE4Dmg:SetJustifyH("LEFT")
	frame.mE4Dmg:SetShadowOffset(1, -1)
	frame.mE4Dmg:SetTextColor(1, 1, 1)
	frame.mE4Dmg:SetText("Dmg")

	-- creating mE4Heal
	frame.mE4Heal = frame:CreateFontString(nil, "OVERLAY")
	frame.mE4Heal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 449, 65)
	frame.mE4Heal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE4Heal:SetJustifyH("LEFT")
	frame.mE4Heal:SetShadowOffset(1, -1)
	frame.mE4Heal:SetTextColor(1, 1, 1)
	frame.mE4Heal:SetText("Heal")

	-- creating mE5Dmg
	frame.mE5Dmg = frame:CreateFontString(nil, "OVERLAY")
	frame.mE5Dmg:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 575, 85)
	frame.mE5Dmg:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE5Dmg:SetJustifyH("LEFT")
	frame.mE5Dmg:SetShadowOffset(1, -1)
	frame.mE5Dmg:SetTextColor(1, 1, 1)
	frame.mE5Dmg:SetText("Dmg")

	-- creating mE5Heal
	frame.mE5Heal = frame:CreateFontString(nil, "OVERLAY")
	frame.mE5Heal:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 575, 65)
	frame.mE5Heal:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.mE5Heal:SetJustifyH("LEFT")
	frame.mE5Heal:SetShadowOffset(1, -1)
	frame.mE5Heal:SetTextColor(1, 1, 1)
	frame.mE5Heal:SetText("Heal")


	MatchView = frame

end

function VFrame:CreateClassView(frameM) -- creates the ClassView 
	
	frameCV = CreateFrame("Frame", "ClassView", frame)
	frameCV:SetSize(700, 680)
	texture = frameCV:CreateTexture()
	texture:SetAllPoints() 
	texture:SetTexture(0,0,0,1) 

	ClassView = frameCV

end

function VFrame:CreateStatView(frameM) -- creates the StatView 

	frame = CreateFrame("Frame", "StatView", frameM)
	frame:SetSize(636, 394)
	frame:SetPoint("CENTER", UIParent)
	texture = frame:CreateTexture()
	texture:SetAllPoints()
	texture:SetTexture(0,0,0,1)
	frame.background = texture

	-- creating borderOut
	frame.borderOut = CreateFrame("Frame", "borderOut", frame)
	frame.borderOut:SetSize(655, 415)
	frame.borderOut:SetFrameStrata("DIALOG")
	frame.borderOut:SetPoint("BOTTOMLEFT", frame, -7, -10)

	backdropS = {
	bgFile = nil,
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 32,
	edgeSize = 32,
	 insets = {
	  left = 11,
	  right = 12,
	  top = 12,
	  bottom = 11
	 }
	}
	frame.borderOut:SetBackdrop(backdropS)

	-- creating sortMaplb
	frame.sortMaplb = frame:CreateFontString(nil, "OVERLAY")
	frame.sortMaplb:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 29, 323)
	frame.sortMaplb:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.sortMaplb:SetJustifyH("LEFT")
	frame.sortMaplb:SetShadowOffset(1, -1)
	frame.sortMaplb:SetTextColor(1, 1, 1)
	frame.sortMaplb:SetText("Map:")

	-- creating sortRankedlb
	frame.sortRankedlb = frame:CreateFontString(nil, "OVERLAY")
	frame.sortRankedlb:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 218, 325)
	frame.sortRankedlb:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.sortRankedlb:SetJustifyH("LEFT")
	frame.sortRankedlb:SetShadowOffset(1, -1)
	frame.sortRankedlb:SetTextColor(1, 1, 1)
	frame.sortRankedlb:SetText("Ranked:")

	-- creating sortSizelb
	frame.sortSizelb = frame:CreateFontString(nil, "OVERLAY")
	frame.sortSizelb:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 433, 326)
	frame.sortSizelb:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.sortSizelb:SetJustifyH("LEFT")
	frame.sortSizelb:SetShadowOffset(1, -1)
	frame.sortSizelb:SetTextColor(1, 1, 1)
	frame.sortSizelb:SetText("Size:")

	-- creating sortMap
	frame.sortMap = CreateFrame("Button", "sortMap", frame, "UIDropDownMenuTemplate")
	frame.sortMap:ClearAllPoints()
	frame.sortMap:SetSize(125, 30)
	frame.sortMap:SetPoint("BOTTOMLEFT", frame, 49, 312)
	 
	local itemsM = {
		"Ruins of Lordaeron",
		"Dalaran Sewers",
		"Nagrand Arena",
		"The Tiger's Peak",
		"Blade's Edge Arena",
		"Tol'Viron Arena",
		"All",
	}

	local function OnClickMap(self)
	  UIDropDownMenu_SetSelectedID(StatView.sortMap, self:GetID())
	end

	local function initializeMap(self, level)
	   local info = UIDropDownMenu_CreateInfo()
	   for k,v in pairs(itemsM) do
	      info = UIDropDownMenu_CreateInfo()
	      info.text = v
	      info.value = v
	      info.func = OnClickMap
	      UIDropDownMenu_AddButton(info, level)
	   end
	end

	UIDropDownMenu_Initialize(frame.sortMap, initializeMap)
	UIDropDownMenu_SetWidth(frame.sortMap, 100);
	UIDropDownMenu_SetButtonWidth(frame.sortMap, 124)
	UIDropDownMenu_SetSelectedID(frame.sortMap, 7)
	UIDropDownMenu_JustifyText(frame.sortMap, "LEFT")

	-- creating sortSize
	frame.sortSize = CreateFrame("Button", "sortSize", frame, "UIDropDownMenuTemplate")
	frame.sortSize:ClearAllPoints()
	frame.sortSize:SetSize(125, 30)
	frame.sortSize:SetPoint("BOTTOMLEFT", frame, 457, 313)

	local itemsS = {
		"2v2",
		"3v3",
		"5v5",
		"All",
	}

	local function OnClickS(self)
	  UIDropDownMenu_SetSelectedID(StatView.sortSize, self:GetID())
	end

	local function initializeS(self, level)
	   local info = UIDropDownMenu_CreateInfo()
	   for k,v in pairs(itemsS) do
	      info = UIDropDownMenu_CreateInfo()
	      info.text = v
	      info.value = v
	      info.func = OnClickS
	      UIDropDownMenu_AddButton(info, level)
	   end
	end

	UIDropDownMenu_Initialize(frame.sortSize, initializeS)
	UIDropDownMenu_SetWidth(frame.sortSize, 100);
	UIDropDownMenu_SetButtonWidth(frame.sortSize, 124)
	UIDropDownMenu_SetSelectedID(frame.sortSize, 4)
	UIDropDownMenu_JustifyText(frame.sortSize, "LEFT")

	-- creating sortRanked
	frame.sortRanked = CreateFrame("Button", "sortRanked", frame, "UIDropDownMenuTemplate")
	frame.sortRanked:ClearAllPoints()
	frame.sortRanked:SetSize(125, 30)
	frame.sortRanked:SetPoint("BOTTOMLEFT", frame, 259, 313)
	 
	local itemsR = {
		"Ranked",
		"Skirmish",
		"All",
	}

	local function OnClickRank(self)
	  UIDropDownMenu_SetSelectedID(StatView.sortRanked, self:GetID())
	end

	local function initializeRank(self, level)
	   local info = UIDropDownMenu_CreateInfo()
	   for k,v in pairs(itemsR) do
	      info = UIDropDownMenu_CreateInfo()
	      info.text = v
	      info.value = v
	      info.func = OnClickRank
	      UIDropDownMenu_AddButton(info, level)
	   end
	end

	UIDropDownMenu_Initialize(frame.sortRanked, initializeRank)
	UIDropDownMenu_SetWidth(frame.sortRanked, 100);
	UIDropDownMenu_SetButtonWidth(frame.sortRanked, 124)
	UIDropDownMenu_SetSelectedID(frame.sortRanked, 3)
	UIDropDownMenu_JustifyText(frame.sortRanked, "LEFT")

	-- creating borderSort
	frame.borderSort = CreateFrame("Frame", "borderSort", frame)
	frame.borderSort:SetSize(600, 80)
	frame.borderSort:SetFrameStrata("DIALOG")
	frame.borderSort:SetPoint("BOTTOMLEFT", frame, 14, 288)

	backdropS = {
	bgFile = nil,
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 32,
	edgeSize = 32,
	 insets = {
	  left = 11,
	  right = 12,
	  top = 12,
	  bottom = 11
	 }
	}
	frame.borderSort:SetBackdrop(backdropS)

	-- creating Iplayed
	frame.Iplayed = frame:CreateFontString(nil, "OVERLAY")
	frame.Iplayed:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 38, 140)
	frame.Iplayed:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.Iplayed:SetJustifyH("LEFT")
	frame.Iplayed:SetShadowOffset(1, -1)
	frame.Iplayed:SetTextColor(1, 1, 1)
	frame.Iplayed:SetText("Played:")

	-- creating Ilost
	frame.Ilost = frame:CreateFontString(nil, "OVERLAY")
	frame.Ilost:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 37, 75)
	frame.Ilost:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.Ilost:SetJustifyH("LEFT")
	frame.Ilost:SetShadowOffset(1, -1)
	frame.Ilost:SetTextColor(1, 1, 1)
	frame.Ilost:SetText("Lost:")

	-- creating Iwon
	frame.Iwon = frame:CreateFontString(nil, "OVERLAY")
	frame.Iwon:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 37, 107)
	frame.Iwon:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.Iwon:SetJustifyH("LEFT")
	frame.Iwon:SetShadowOffset(1, -1)
	frame.Iwon:SetTextColor(1, 1, 1)
	frame.Iwon:SetText("Won:")

	-- creating Iratio
	frame.Iratio = frame:CreateFontString(nil, "OVERLAY")
	frame.Iratio:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 36, 43)
	frame.Iratio:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.Iratio:SetJustifyH("LEFT")
	frame.Iratio:SetShadowOffset(1, -1)
	frame.Iratio:SetTextColor(1, 1, 1)
	frame.Iratio:SetText("Ratio:")

	-- creating IplayedAgainst
	frame.IplayedAgainst = frame:CreateFontString(nil, "OVERLAY")
	frame.IplayedAgainst:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 350, 140)
	frame.IplayedAgainst:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.IplayedAgainst:SetJustifyH("LEFT")
	frame.IplayedAgainst:SetShadowOffset(1, -1)
	frame.IplayedAgainst:SetTextColor(1, 1, 1)
	frame.IplayedAgainst:SetText("Most Played against:")

	-- creating borderBot
	frame.borderBot = CreateFrame("Frame", "borderBot", frame)
	frame.borderBot:SetSize(600, 110)
	frame.borderBot:SetFrameStrata("DIALOG")
	frame.borderBot:SetPoint("BOTTOMLEFT", frame, 13, 177)

	backdropS = {
	bgFile = nil,
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 32,
	edgeSize = 32,
	 insets = {
	  left = 11,
	  right = 12,
	  top = 12,
	  bottom = 11
	 }
	}
	frame.borderBot:SetBackdrop(backdropS)

	-- creating borderMid
	frame.borderMid = CreateFrame("Frame", "borderMid", frame)
	frame.borderMid:SetSize(600, 160)
	frame.borderMid:SetFrameStrata("DIALOG")
	frame.borderMid:SetPoint("BOTTOMLEFT", frame, 13, 16)

	backdropS = {
	bgFile = nil,
	edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
	tile = true,
	tileSize = 32,
	edgeSize = 32,
	 insets = {
	  left = 11,
	  right = 12,
	  top = 12,
	  bottom = 11
	 }
	}
	frame.borderMid:SetBackdrop(backdropS)

	-- creating Ienemy1
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(172849)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.Ienemy1 = CreateFrame("Frame", "Ienemy1", frame)
	frame.Ienemy1:SetSize(70, 70)
	frame.Ienemy1:SetFrameStrata("DIALOG")
	frame.Ienemy1:SetPoint("BOTTOMLEFT", frame, 352, 51)
	frame.Ienemy1:SetBackdrop(backdropS)
	frame.Ienemy1:SetScript("OnMouseUp", function ()  end)

	-- creating Ienemy2
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(172849)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.Ienemy2 = CreateFrame("Frame", "Ienemy2", frame)
	frame.Ienemy2:SetSize(70, 70)
	frame.Ienemy2:SetFrameStrata("DIALOG")
	frame.Ienemy2:SetPoint("BOTTOMLEFT", frame, 439, 51)
	frame.Ienemy2:SetBackdrop(backdropS)
	frame.Ienemy2:SetScript("OnMouseUp", function ()  end)

	-- creating IenemyStats
	frame.IenemyStats = frame:CreateFontString(nil, "OVERLAY")
	frame.IenemyStats:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 352, 28)
	frame.IenemyStats:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.IenemyStats:SetJustifyH("LEFT")
	frame.IenemyStats:SetShadowOffset(1, -1)
	frame.IenemyStats:SetTextColor(1, 1, 1)
	frame.IenemyStats:SetText("No Enemy Stats")

	-- creating Imap
	backdropS = {
	  -- path to the background texture
	  bgFile = select(3, GetSpellInfo(172849)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	frame.Imap = CreateFrame("Frame", "Imap", frame)
	frame.Imap:SetSize(80, 80)
	frame.Imap:SetFrameStrata("DIALOG")
	frame.Imap:SetPoint("BOTTOMLEFT", frame, 40, 191)
	frame.Imap:SetBackdrop(backdropS)
	frame.Imap:SetScript("OnMouseUp", function ()  end)

	-- creating ImapRank
	frame.ImapRank = frame:CreateFontString(nil, "OVERLAY")
	frame.ImapRank:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 169, 217)
	frame.ImapRank:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.ImapRank:SetJustifyH("LEFT")
	frame.ImapRank:SetShadowOffset(1, -1)
	frame.ImapRank:SetTextColor(1, 1, 1)
	frame.ImapRank:SetText("Map Rank:")

	-- creating IavTime
	frame.IavTime = frame:CreateFontString(nil, "OVERLAY")
	frame.IavTime:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 315, 217)
	frame.IavTime:SetFont("Fonts\\ARIALN.TTF", 15, "OUTLINE")
	frame.IavTime:SetJustifyH("LEFT")
	frame.IavTime:SetShadowOffset(1, -1)
	frame.IavTime:SetTextColor(1, 1, 1)
	frame.IavTime:SetText("Average Time:")

	-- creating Istate
	frame.Istate = CreateFrame("Frame", "Istate", frame)
	frame.Istate:SetSize(80, 80)
	frame.Istate:SetFrameStrata("DIALOG")
	frame.Istate:SetPoint("BOTTOMLEFT", frame, 506, 191)
	texture = frame.Istate:CreateTexture()
	texture:SetAllPoints()
	texture:SetTexture(0.5,0.5,0.5,1)
	frame.Istate.texture = texture

	frame.setFilter = CreateFrame("Button", "setFilter", frame, "UIPanelButtonTemplate")
	frame.setFilter:SetSize(80, 25)
	frame.setFilter:SetPoint("TOP", frame, 250, -5)
	frame.setFilter.text = _G["setFilter" .. "Text"]
	frame.setFilter.text:SetText("Filter")
	frame.setFilter:SetScript("OnMouseDown", function () VFrame:FilterStats() end) 


	StatView = frame

end

function VFrame:UpdateInfoFrame() -- Updates the Info Frame with ranked infos 

	if firstPvPUpdate then
		TogglePVPUI()
		firstPvPUpdate = false
		TogglePVPUI()
	end

	if select(1, LA:getRankedInfo(1)) == 0 then self:ScheduleTimer("UpdateInfoFrame", 2); return end

	InfoFrame.z:SetText(select(4, LA:getRankedInfo(1)))
	InfoFrame.t:SetText(select(4, LA:getRankedInfo(2)))
	InfoFrame.f:SetText(select(4, LA:getRankedInfo(3)))

	wins, looses, ratio, rating = LA:getRankedInfo(1)

	InfoFrame.w:SetText("W: " .. wins)
	InfoFrame.l:SetText("L: " .. looses)
	InfoFrame.r:SetText("R: " .. ratio .. "%")

	InfoFrame.z2:SetText("2v2")
	InfoFrame.f2:SetText("3v3")
	InfoFrame.t2:SetText("5v5")

	InfoFrame.b:Enable()

end

function VFrame:StatFrameButton() -- the statistic button on the info frame 

	if StatFrame:IsShown() then 
		StatFrame:Hide(); return 
	else 
		StatFrame:Show()

		-- handle all data set/update all strings, icons, information
		self:StatFrameUpdateMatches(1)	

		-- handle all data to fill mini infos at the Statistic Frame Bottom
		self:handleShortInfos()

	end

end

function VFrame:handleShortInfos() -- fills the overall view elements in the Statistics view with data 
	
	specs = {}
	ranked = {}
	size = {}
	map =  {}

	ranked[1] = true; ranked[2] = false
	size[1] = 2; size[2] = 3; size[3] = 5
	map[1] = 1; map[2] = 2; map[3] = 3; map[4] = 4; map[5] = 5; map[6] = 6

	count = 0
	for i,n in pairs(StatDB) do
		if contains(ranked, n.ranked) then
			if contains(size, tonumber(split(n.size, "v", false))) then
				if contains(map, n.map) then
					count = count + 1
					for i2,n2 in pairs(n.specs) do
						if not specs[n2] then specs[n2] = 0 end
						specs[n2] = specs[n2] + 1
					end
				end
			end
		end
	end

	class1, class2, v1, v2 = self:sortEnemyRank(specs)

	StatFrame.e1:SetBackdrop(self:getBackdrop(select(4, GetSpecializationInfoByID(class1))))
	StatFrame.e2:SetBackdrop(self:getBackdrop(select(4, GetSpecializationInfoByID(class2))))

	self:updatePvPPoints()
	points = PointDB[date("%d.%m.%Y")]
	StatFrame.cp:SetText("Conquest Points Today: " .. points.cp .. " / " .. points.cpA)
	StatFrame.hp:SetText("Honor Points Today: " .. points.hp .. " / " .. points.hpA)

end

function VFrame:HandlePlayedArena(match, players) -- handles all the info for the last 5 played arenas (sorting and shifting) 

	matches = MatchDB
	matches[5] = matches[4]
	matches[4] = matches[3]
	matches[3] = matches[2]
	matches[2] = matches[1]

	newMatch = {}
		newMatch.size = match.size
		newMatch.win = match.win
		newMatch.map = match.map
		newMatch.ranked = match.ranked
		newMatch.time = match.time
		newMatch.ownFac = match.ownFac
		newMatch.rating = match.rating

	newMatch.players = players

	matches[1] = newMatch
	MatchDB = matches

	self:SaveDB()

end

function VFrame:MATCH_INFO_UPDATE(event, match, players) -- Is fired from LibArena, prints out some match informations and handles the next steps 
	
	if not match then self:print("Can't get Match-Infos!"); return end

	-------Printing infos-----------
	if not match.ranked then self:print("Skirmish, " .. match.size)
	else self:print("Ranked, " .. match.size .. " on " .. match.rating) end
	if match.win then self:print("Won! in " .. match.map) else self:print("Lost! in " .. match.map) end
	self:print("Estimated Time: " .. SecondsToTime(match.time))

	matchenemys = {}
	for i,n in pairs(players.enemys) do
		if n.state == "normal" then
			classStat = {}
			 classStat.dmg = n.dmg
			 classStat.heal = n.heal
			 if match.win then classStat.win = true else classStat.win = false end
			 classStat.rating = n.rating
			 classStat.spec = n.spec
			 classStat.name = n.name

			matchenemys[i] = n.spec

			self:AddClassStats(classStat)
			self:print("Stat added: " .. n.name)
		end
	end

	self:AddMatchStats(match, matchenemys)
	self:HandlePlayedArena(match, players)

end

function VFrame:StatFrameUpdateMatches(index) -- Updates the MatchView when statistic button is pressed (calculates most things) 

	matches = MatchDB
	match = matches[index]

	MatchViewtbl.mIcon = MatchView.mIcon

	for i,n in pairs(zc) do
		m = MatchViewtbl.m
		group = m[i]
		if matches[i].win then 
			texture = group.wl.texture:SetTexture(0, 1, 0, 1) 
		else 
			texture = group.wl.texture:SetTexture(1, 0, 0, 1) 
		end	

		group.size:SetText(matches[i].size)

		group.icon:SetBackdrop(self:getBackdrop(mapImg[LA:getMapIndex(matches[i].map, false)]))
	end

	MatchViewtbl.mIcon:SetBackdrop(self:getBackdrop(mapImg[LA:getMapIndex(match.map, false)]))
	if match.win then MatchView.mWL.texture:SetTexture(0, 1, 0, 1) else MatchView.mWL.texture:SetTexture(1, 0, 0, 1) end
	MatchView.mIconS:SetText(match.map)
	MatchView.mSize:SetText(match.size)
	if match.ranked then MatchView.mRating:SetText("Rating: "..match.rating); MatchView.mRanked:SetText("Ranked") else MatchView.mRating:SetText("No Rating"); MatchView.mRanked:SetText("Skirmish") end 
	MatchView.mTime:SetText(SecondsToTime(match.time))


	allDmgP = 0; allHealP = 0
	allDmgE = 0; allHealE = 0

	players = match.players
	team = players.team
	enemys = players.enemys

	ranks = {}
	for i,n in pairs(team) do
		table.insert(ranks, n.dmg + n.heal)
	end
	for i,n in pairs(enemys) do
		table.insert(ranks, n.dmg + n.heal)
	end

	function comp(w1,w2)
        if w1 > w2 then
            return true
        end
    end

    table.sort(ranks, comp)

	for i,n in pairs(team) do
		self:AddPlayer(n, i, true, ranks)
		allDmgP = allDmgP + n.dmg
		allHealP = allHealP + n.heal
	end

	for i,n in pairs(enemys) do
		self:AddPlayer(n, i, false, ranks)
		allDmgE = allDmgE + n.dmg
		allHealE = allHealE + n.heal
	end

	MatchView.mPDmg:SetText(allDmgP)
	MatchView.mPHeal:SetText(allHealP)
	MatchView.mEDmg:SetText(allDmgE)
	MatchView.mEHeal:SetText(allHealE)

end

function VFrame:AddPlayer(infos, i, ownTeam, ranks) -- Adds a player to the matchview 

	backdropS = {
	  -- path to the background texture
	  bgFile = select(4, GetSpecializationInfoByID(infos.spec)),
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	nameS = split(infos.name, "-", false)

	if infos.state == "normal" then
		if ownTeam then
			group = MatchViewtbl.mP[i]
			group.Icon:SetBackdrop(backdropS); group.Name:SetText(nameS); 
			group.Dmg:SetText(infos.dmg); group.Heal:SetText(infos.heal)
			self:createPlayerTooltips(group, infos, ranks)
		else
			group = MatchViewtbl.mE[i]
			group.Icon:SetBackdrop(backdropS); group.Name:SetText(nameS); 
			group.Dmg:SetText(infos.dmg); group.Heal:SetText(infos.heal)
			self:createPlayerTooltips(group, infos, ranks)
		end
	elseif infos.state == "cleared" then
		if ownTeam then
			group = MatchViewtbl.mP[i]
			group.Icon:SetBackdrop(self:getBackdrop(pImg.cleared)); group.Name:SetText(nameS); 
			group.Dmg:SetText("Leaved or AFK"); group.Heal:SetText("")
			self:createPlayerTooltips(group, infos, ranks)
		else
			group = MatchViewtbl.mE[i]
			group.Icon:SetBackdrop(self:getBackdrop(pImg.cleared)); group.Name:SetText(nameS); 
			group.Dmg:SetText("Leaved or AFK"); group.Heal:SetText("")
			self:createPlayerTooltips(group, infos, ranks)
		end
	else -- infos.state == "ni"
		if ownTeam then
			group = MatchViewtbl.mP[i]
			group.Icon:SetBackdrop(self:getBackdrop(pImg.ni)); group.Name:SetText(""); 
			group.Dmg:SetText(""); group.Heal:SetText("")
			group.Icon:SetScript("OnEnter", nil); group.Icon:SetScript("OnLeave", nil)
		else
			group = MatchViewtbl.mE[i]
			group.Icon:SetBackdrop(self:getBackdrop(pImg.ni)); group.Name:SetText("")
			group.Dmg:SetText(""); group.Heal:SetText("")
			group.Icon:SetScript("OnEnter", nil); group.Icon:SetScript("OnLeave", nil)
		end
	end

end

function VFrame:FilterStats() -- Gets the data about all matches with the filter and shows it in the StatView 
	
	ranked = {}
	size = {}
	map = {}

	rankedR = UIDropDownMenu_GetSelectedID(StatView.sortRanked)
	itemsR = {
		[1] = "Ranked",
		[2] = "Skirmish",
		[3] = "All",
	}
	rankedR = itemsR[rankedR]
	if rankedR == "Ranked" then 
		ranked[1] = true 
	elseif rankedR == "All" then 
		ranked[1] = true; ranked[2] = false 
	else 
		ranked[1] = false 
	end

	sizeR = UIDropDownMenu_GetSelectedID(StatView.sortSize)
	itemsS = {
		[1] = "2v2",
		[2] = "3v3",
		[3] = "5v5",
		[4] = "All",
	}
	sizeR = itemsS[sizeR]
	if sizeR == "2v2" then 
		size[1] = 2 
	elseif sizeR == "3v3" then 
		size[1] = 3 
	elseif sizeR == "All" then 
		size[1] = 2; size[2] = 3; size[3] = 5 
	else 
		size[1] = 5 
	end

	mapR = UIDropDownMenu_GetSelectedID(StatView.sortMap)
	itemsM = {
		[1] = "Ruins of Lordaeron",
		[2] = "Dalaran Sewers",
		[3] = "Nagrand Arena",
		[4] = "The Tiger's Peak",
		[5] = "Blade's Edge Arena",
		[6] = "Tol'Viron Arena",
		[7] = "All",
	}
	mapR = itemsM[mapR]
	if mapR == "All" then 
		map[1] = 1; map[2] = 2; map[3] = 3; map[4] = 4; map[5] = 5; map[6] = 6
	else 
		map[1] = LA:getMapIndex(mapR, false, "enUS") 
	end

	stats = {}
	 stats.played = 0
	 stats.won = 0
	 stats.lost = 0
	 stats.ratio = 0
	 stats.class1 = 0
	 stats.class2 = 0
	 stats.map = 0
	 stats.maprank = 0
	 stats.avtime = 0
	  specs = {}

	  maps = {
		["Ruins of Lordaeron"] = 0,
		["Dalaran Sewers"] = 0,
		["Nagrand Arena"] = 0,
		["The Tiger's Peak"] = 0,
		["Blade's Edge Arena"] = 0,
		["Tol'Viron Arena"] = 0,
	}
	for i,n in pairs(StatDB) do
		if contains(ranked, n.ranked) then
			if contains(size, tonumber(split(n.size, "v", false))) then
				maps[itemsM[n.map]] = maps[itemsM[n.map]] + 1
			end
		end
	end

	ranks = self:sortMapRank(maps)

	count = 0
	for i,n in pairs(StatDB) do
		if contains(ranked, n.ranked) then
			if contains(size, tonumber(split(n.size, "v", false))) then
				if contains(map, n.map) then
					stats.played = stats.played + 1
					if n.win then stats.won = stats.won + 1 end		
					stats.map = n.map
					stats.avtime = stats.avtime + n.time
					count = count + 1
					for i2,n2 in pairs(n.specs) do
						if not specs[n2] then specs[n2] = 0 end
						specs[n2] = specs[n2] + 1
					end
				end
			end
		end
	end

	if count == 0 then StatView.ImapRank:SetText("No Matches found"); StatView.Imap:SetBackdrop(self:getBackdrop(mapImg[map[1]]))
		StatView.IavTime:SetText("")
		StatView.Iplayed:SetText("Played: ")
		StatView.Iwon:SetText("Won: ")
		StatView.Ilost:SetText("Lost: ")
		StatView.Iratio:SetText("Ratio: ")
		StatView.Ienemy1:SetBackdrop(self:getBackdrop(pImg.cleared))
		StatView.Ienemy2:SetBackdrop(self:getBackdrop(pImg.cleared))
	else

		stats.lost = stats.played - stats.won
		stats.ratio = (stats.won/stats.played)*100

		StatView.Imap:SetBackdrop(self:getBackdrop(mapImg[stats.map]))
		StatView.ImapRank:SetText(itemsM[stats.map] .. "\nMap Rank: " .. ranks[itemsM[map[1]]])
		StatView.IavTime:SetText("Average Time: \n" .. SecondsToTime(tostring(stats.avtime / stats.played)))
		StatView.Iplayed:SetText("Played: "..stats.played)
		StatView.Iwon:SetText("Won: "..stats.won)
		StatView.Ilost:SetText("Lost: "..stats.lost)
		StatView.Iratio:SetText("Ratio: ".. self:round(stats.ratio) .. "%")
		if stats.ratio > 49 then 
			StatView.Istate.texture:SetTexture(0, 1, 0, 1)
		else
			StatView.Istate.texture:SetTexture(1, 0, 0, 1)
		end

		class1, class2, v1, v2 = self:sortEnemyRank(specs)

		backdropS = {
		  bgFile = select(4, GetSpecializationInfoByID(class1)),
		  tile = false,
		  tileSize = 20
		}
		StatView.Ienemy1:SetBackdrop(backdropS)

		backdropS = {
		  bgFile = select(4, GetSpecializationInfoByID(class2)),
		  tile = false,
		  tileSize = 20
		}

		StatView.Ienemy2:SetBackdrop(backdropS)

		v1 = (100*v1) / count; v2 = (100*v2) / count
		StatView.IenemyStats:SetText("     " .. self:round(v1) .. "%" .. "                " .. self:round(v2) .. "%")

		if mapR == "All" then 

			rankAll = 0

			for i,n in pairs(ranks) do
				if n == 1 then rankAll = i end
			end

			if rankeAll == 0 then
				StatView.Imap:SetBackdrop(self:getBackdrop(pImg.ni))	
				StatView.ImapRank:SetText("No Matches played!")
			else
				StatView.Imap:SetBackdrop(self:getBackdrop(mapImg[LA:getMapIndex(rankAll, false, "enUS")]))
				StatView.ImapRank:SetText("Rank 1 Map: " .. "\n" .. rankAll)
			end

		end
	end

end

---------------Misc Methods-----------------

function VFrame:updatePvPPoints() -- updates the PvP points 
	
	points = PointDB[date("%d.%m.%Y")]

	points.cpA = select(6, GetCurrencyListInfo(11))
	points.hpA = select(6, GetCurrencyListInfo(10))
	points.cp = select(6, GetCurrencyListInfo(11)) - points.cpO
	points.hp = select(6, GetCurrencyListInfo(10)) - points.hpO

	PointDB[date("%d.%m.%Y")] = points

end

function VFrame:getBackdrop(path) -- gets an bockdrop object with the image from the path as the background 
	backdropS = {
	  -- path to the background texture
	  bgFile = path,
	  -- true to repeat the background texture to fill the frame, false to scale it
	  tile = false,
	  -- size (width or height) of the square repeating background tiles (in pixels)
	  tileSize = 20
	}

	return backdropS

end

function VFrame:sortMapRank(tbl) -- creates a table with the ranks for all arena-maps 

	function spairs(t, order)
	    local keys = {}
	    for k in pairs(t) do keys[#keys+1] = k end

	    if order then
	        table.sort(keys, function(a,b) return order(t, a, b) end)
	    else
	        table.sort(keys)
	    end

	    local i = 0
	    return function()
	        i = i + 1
	        if keys[i] then
	            return keys[i], t[keys[i]]
	        end
	    end
	end


	    ranks = {}

	    num = 0
	    for k,v in spairs(tbl, function(t,a,b) return t[b] < t[a] end) do
	    	num = num  + 1
		    ranks[k] = num
		end


	    return ranks

end

function VFrame:sortEnemyRank(tbl) -- creates a table with the ranks for all arena-enemys 
	
		function spairs(t, order)
		    local keys = {}
		    for k in pairs(t) do keys[#keys+1] = k end

		    if order then
		        table.sort(keys, function(a,b) return order(t, a, b) end)
		    else
		        table.sort(keys)
		    end

		    local i = 0
		    return function()
		        i = i + 1
		        if keys[i] then
		            return keys[i], t[keys[i]]
		        end
		    end
		end

		class1 = 0
		class2 = 0

		num = 0
	    for k,v in spairs(tbl, function(t,a,b) return t[b] < t[a] end) do
	    	num = num  + 1
		    if num == 1 then class1 = k; v1 = v elseif num == 2 then class2 = k; v2 = v end
		end

		return class1, class2, v1, v2

end

--------------DB functions----------------

function VFrame:AddMatchStats(matchO, matchenemys) -- adds informatsions about a played match to the StatDB 
	-- match.win, match.time, match.map, match.size, match.ranked

	match = {}
	match.size = matchO.size
	match.win = matchO.win
	match.time = matchO.time
	match.ranked = matchO.ranked
	match.map = LA:getMapIndex(matchO.map, false)
	specs = {}
		for i,n in pairs(matchenemys) do
			specs[i] = n
		end
	match.specs = specs

	-- match.win, match.map. match.size, match.ranked, match.time, match.specs
	table.insert(StatDB, match)

end

function VFrame:AddClassStats(infosO) -- adds informations about a enemy player to the ClassDB 
	-- infos.win, infos.name, infos.kills, infos.faction, infos.race, infos.class, infos.classToken, infos.dmg, infos.heal, infos.spec

	infos = {}

	infos.dmg = infosO.dmg
	infos.heal = infosO.heal
	infos.spec = infosO.spec
	infos.win = infosO.win
	infos.name = infosO.name

	table.insert(ClassDB[infosO.spec], infos)

	--for i,n in pairs(ClassDB[infosO.spec]) do 
		--print(n.spec)
	--end

end

-------------------------------------------

function VFrame:print(msg) -- the print funktion with the Red VFrame before every chat msg 

	print("|cffff0020VFrame|r: " .. msg)

end

function VFrame:round(n) -- rounds a value 

    return n % 1 >= 0.5 and math.ceil(n) or math.floor(n)

end

function contains(tbl, value) -- returns true if the value is existent in the given tbl 

	for i,n in pairs(tbl) do
		if n == value then return true end
	end

	return false
	
end

function split(inputstr, sep, tbl) -- splits a string 

        local t={} ; i=1
        for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
                t[i] = str
                i = i + 1
        end

        if tbl then return t else return t[1] end

end

function getIndex(tbl, value) -- returns the index where the value is in the table 
	
	for i,n in pairs(tbl) do
		if n == value then return i end
	end

end

----------------------------------------------